<?php

/**
 * @author Sergey Jdanuk aka Shadoof <jdanuk at gmail.com>
 */
class Welcome extends Screen
{
	function getActionPlay(){
		$stream = Rise::$config->load('streams.stream');
		return array
		(
			GuiAction::handler_string_id => PLUGIN_TV_PLAY_ACTION_ID,
			GuiAction::data =>array('media_url' => Media_Url::encode("Welcome->playTV",array($stream)))
		);
	}

    function input (&$arg)
    {
	    hd_print( __METHOD__ );
	    return self::getActionPlay();
    }

	function index(){
		return self::getActionPlay();
	}

	function playTV($stream)
	{
		hd_print( __METHOD__ . ' ' . $stream );

		$id = "1";

		$groups = array(
			array
			(
				PluginTvGroup::id       => '0',
				PluginTvGroup::caption  => 'Все каналы',
				PluginTvGroup::icon_url => 'gui_skin://small_icons/iptv.aai',
			)
		);
		$channels = array(
			array(
				PluginTvChannel::id                => (string)$id,
				PluginTvChannel::caption           => "Vevo",
				PluginTvChannel::group_ids         => array('0'),
				PluginTvChannel::icon_url          => "http://commons.wikimedia.org/wiki/File:Vevo-logo-640x223.png",
				PluginTvChannel::number            => -1,
				PluginTvChannel::have_archive      => FALSE,
				PluginTvChannel::is_protected      => FALSE,
				PluginTvChannel::past_epg_days     => 0,
				PluginTvChannel::future_epg_days   => 0,
				PluginTvChannel::archive_past_sec  => 0,
				PluginTvChannel::archive_delay_sec => 0,
				PluginTvChannel::buffering_ms      => 0,
				PluginTvChannel::timeshift_hours   => 0,
				PluginTvChannel::playback_url_is_stream_url => TRUE
			)
		);

		$tv = array
		(
			PluginTvInfo::show_group_channels_only  => TRUE,
			PluginTvInfo::groups                    => $groups,
			PluginTvInfo::channels                  => $channels,
			PluginTvInfo::favorites_supported       => FALSE,
			PluginTvInfo::favorites_icon_url        => 'gui_skin://small_icons/favorites.aai',
			PluginTvInfo::initial_channel_id        => $id,
			PluginTvInfo::initial_group_id          => 0,
			PluginTvInfo::initial_is_favorite       => FALSE,
			PluginTvInfo::favorite_channel_ids      => array(),
			PluginTvInfo::archive                   => NULL,
		);
		return $tv;
	}

	static function get_day_epg($id, $day_start_ts)	{
		hd_print( __METHOD__ );
		return array();
	}

	static function get_tv_stream_url($media_url){
		hd_print( __METHOD__ );
		return $media_url;
	}

	static function get_tv_playback_url($media_url){
		hd_print( __METHOD__ );
		return Rise::$config->load('streams.stream');
	}
}
