<?php
class Folder_View_Regular extends Folder_View
{
    private $items = array();
    private $config = "default";
    private $PluginRegularFolderView_actions = array();
    private $PluginRegularFolderView_initial_range = array(
        PluginRegularFolderRange::from_ndx => 0,
        PluginRegularFolderRange::more_items_available => FALSE,
    );
    private $PluginFolderView_data = array(
        PluginRegularFolderView::async_icon_loading => false
    );
    
    private $PluginRegularFolderView_view_params = array();
    private $PluginRegularFolderView_base_view_item_params = array();
    private $PluginRegularFolderView_not_loaded_view_item_params = array();
    
    public static function factory($config = null)
    {
        return new Folder_View_Regular($config);
    }
    
    public function __construct($config = null)
    {
        if( !is_null($config) && is_string($this->config) )
            $this->config = $config;
        
        $this->PluginRegularFolderView_view_params = Rise::$config->load("folder/regular.view_params.".$this->config);
        $this->PluginRegularFolderView_base_view_item_params = Rise::$config->load("folder/regular.base_view_item_params.".$this->config);
        $this->PluginRegularFolderView_not_loaded_view_item_params = Rise::$config->load("folder/regular.not_loaded_view_item_params.".$this->config);
    }
    
    public function addItem($caption, $media_url, $view_item_params = null)
    {
        $configViewItemParams = Rise::$config->load("folder/regular.view_item_params.".$this->config);
        if(!is_null($view_item_params) && is_array($view_item_params))
        {
            $configViewItemParams = Arr::merge($configViewItemParams, $view_item_params);
//            var_dump($configViewItemParams);
        }
        $this->items[] = array(
            PluginRegularFolderItem::caption => $caption,
            PluginRegularFolderItem::view_item_params => $configViewItemParams,
            PluginRegularFolderItem::media_url => $media_url
        );
        return $this;
    }
    
    public function clearItems()
    {
        $this->items = array();
    }
    
    private function _merge( $classMember, $arr )
    {
        if( !is_null($arr) && is_array($arr) )
        {
            $this->$classMember = Arr::merge($this->$classMember, $arr);
        }
        return $this->$classMember;
    }
    
    function view_params($arr = null)
    {
        return $this->_merge('PluginRegularFolderView_view_params', $arr);
    }
    
    function base_view_item_params($arr = null)
    {
        return $this->_merge('PluginRegularFolderView_base_view_item_params', $arr);
    }
    function not_loaded_view_item_params($arr = null)
    {
        return $this->_merge('PluginRegularFolderView_not_loaded_view_item_params', $arr);
    }
    
    function initial_range($arr = null)
    {
        $this->_merge('PluginRegularFolderView_initial_range', $arr);
        return $this;
    }
    function addAction( $action )
    {
        $this->PluginRegularFolderView_actions = Arr::merge($this->PluginRegularFolderView_actions, $action);
        return $this;
    }
    function items( $items )
    {
        $this->items = $items;
        return $this;
    }
    function data($arr = null)
    {
        $this->_merge('PluginFolderView_data', $arr);
        
        $this->_merge('PluginFolderView_data', array
        (
            PluginRegularFolderView::initial_range => $this->PluginRegularFolderView_initial_range,
            PluginRegularFolderView::view_params => $this->PluginRegularFolderView_view_params,
            PluginRegularFolderView::base_view_item_params => $this->PluginRegularFolderView_base_view_item_params,
            PluginRegularFolderView::not_loaded_view_item_params => $this->PluginRegularFolderView_not_loaded_view_item_params,
            PluginRegularFolderView::actions => $this->PluginRegularFolderView_actions
        ));

        return $this->PluginFolderView_data;
    }
    
    function create($arr = array())
    {
        $this->initial_range(array
        (
            PluginRegularFolderRange::total => count($this->items),
            PluginRegularFolderRange::count => count($this->items),
            PluginRegularFolderRange::items => $this->items
        ));

        return Arr::merge(array
        (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::data => $this->data()
        ),$arr);
    }
}
