<?php defined('SYSPATH') or die('No direct script access.');
class Rise_I18n {
	public static $lang = 'en-us';
	public static $source = 'en-us';
	protected static $_cache = array();
	public static function lang($lang = NULL)
	{
		if ($lang)
		{
			// Normalize the language
			I18n::$lang = strtolower(str_replace(array(' ', '_'), '-', $lang));
		}

		return I18n::$lang;
	}
	public static function get($string, $lang = NULL)
	{
		if ( ! $lang)
		{
			// Use the global target language
			$lang = I18n::$lang;
		}

		// Load the translation table for this language
		$table = I18n::load($lang);

		// Return the translated string if it exists
		return isset($table[$string]) ? $table[$string] : $string;
	}
	public static function load($lang)
	{
		if (isset(I18n::$_cache[$lang]))
		{
			return I18n::$_cache[$lang];
		}

		$table = array();
		$parts = explode('-', $lang);

		do
		{
			$path = implode(DIRECTORY_SEPARATOR, $parts);

			if ($files = Rise::find_file('i18n', $path, NULL, TRUE))
			{
				$t = array();
				foreach ($files as $file)
				{
					$t = array_merge($t, Rise::load($file));
				}
				$table += $t;
			}

			array_pop($parts);
		}
		while ($parts);

		return I18n::$_cache[$lang] = $table;
	}

} // End I18n

if ( ! function_exists('__'))
{
	function __($string, array $values = NULL, $lang = 'en-us')
	{
		if ($lang !== I18n::$lang)
		{
			$string = I18n::get($string);
		}

		return empty($values) ? $string : strtr($string, $values);
	}
}
